#!/bin/bash
CPQARRAY_VERSION=2
CPQARRAY_PATCHLEVEL=4
CPQARRAY_SUBLEVEL=25

CCISS_VERSION=2
CCISS_PATCHLEVEL=4
CCISS_SUBLEVEL=44

cpqarray_status=0
cciss_status=0

CPQARRAY_DRIVER_FILE=\
`/sbin/insmod -p cpqarray 2>/dev/null|grep Using|sed -e 's/Using //'`
CCISS_DRIVER_FILE=\
`/sbin/insmod -p cciss 2>/dev/null|grep Using|sed -e 's/Using //'`
[ "$CPQARRAY_DRIVER_FILE" != "" ] && [ -f $CPQARRAY_DRIVER_FILE ] && {
	VER=`modinfo -d cpqarray | sed -e 's/.* \([0-9]\+\.[0-9]\+\.[0-9]\+\)*.*/\1/g'`
    VERSION=`echo "$VER" | sed 's|[.]| |g' | awk '{print $1}'`
	PATCHLEVEL=`echo "$VER" | sed 's|[.]| |g' | awk '{print $2}'` 
	SUBLEVEL=`echo "$VER" | sed 's|[.]| |g' | awk '{print $3}'` 

	if [ $[$VERSION] -ge $CPQARRAY_VERSION ]; then
		if [ $[$PATCHLEVEL] -ge $CPQARRAY_PATCHLEVEL ]; then
			if [ $[$SUBLEVEL] -ge $CPQARRAY_SUBLEVEL ]; then
				echo " " > /dev/null
			else
				cpqarray_status=1 
			fi
		else
			cpqarray_status=1
		fi
	else
		cpqarray_status=1
	fi

	[ $cpqarray_status -eq 1 ] && {
		echo " "
		echo " "
		echo "	********************************************************"
		echo "	WARNING: The version of cpqarray driver should be"
		echo "	greater than or equal to "$CPQARRAY_VERSION"."$CPQARRAY_PATCHLEVEL"."$CPQARRAY_SUBLEVEL". "
		echo "	If you have cpqarray controllers, "
		echo "	please upgrade your cpqarray driver for proper "
		echo "	functionality of Array Configuration Utility."
		echo "	********************************************************"
	}
	echo " " > /dev/null

}

[ "$CCISS_DRIVER_FILE" != "" ] && [ -f $CCISS_DRIVER_FILE ] && {
	VER=`modinfo -d cciss | sed -e 's/.* \([0-9]\+\.[0-9]\+\.[0-9]\+\)*.*/\1/g'`
	VERSION=`echo "$VER" | sed 's|[.]| |g' | awk '{print $1}'`
	PATCHLEVEL=`echo "$VER" | sed 's|[.]| |g' | awk '{print $2}'`
	SUBLEVEL=`echo "$VER" | sed 's|[.]| |g' | awk '{print $3}'`

	if [ $[$VERSION] -ge $CCISS_VERSION ]; then
		if [ $[$PATCHLEVEL] -ge $CCISS_PATCHLEVEL ]; then
			if [ $[$SUBLEVEL] -ge $CCISS_SUBLEVEL ]; then
				echo " " > /dev/null
			else
				cciss_status=1
			fi
		else
			cciss_status=1
		fi
	else
		cciss_status=1
	fi

	[ $cciss_status -eq 1 ] && {
		echo " "
		echo " "
		echo "	********************************************************"
		echo "	WARNING: The version of cciss driver should be greater"
		echo "	than or equal to "$CCISS_VERSION"."$CCISS_PATCHLEVEL"."$CCISS_SUBLEVEL". "
		echo "	If you have cciss controllers, "
		echo "	please upgrade your cciss driver for proper "
		echo "	functionality of Array Configuration Utility."
		echo "	********************************************************"
	}
	echo " " > /dev/null
}
echo " " > /dev/null
echo ""
echo "DOWNGRADE NOTE: To downgrade this application to any version prior to 9.10.x.x, the current RPM must be manually uninstalled using the \"rpm -e\" command before any prior versions can be installed."
echo ""
echo "LOCKING NOTE: The locking mechanism starting with versions 9.10.X.X, are not compatible with prior versions of the applications. Therefore, mixing older and newer versions of the various applications (ACU, HPACUCLI, HPACUSCRIPTING) is not recommended."
echo ""